#include <avr/io.h>
#include <avr/interrupt.h>


#define YARMDAVR 135
#define QADAM 5
#define LIGHT_ON  PORTD|=(1<<PD7)
#define LIGHT_OFF PORTD &= ~(1<<PD7)

unsigned int taqqos;
char jarayon;

void Setup(void)
{
	
PORTB=0x03;
DDRB=0x00;


PORTD=0x80;
DDRD=0x80;


TCCR0=0x00;
TCNT0=0x00;

TCCR2=0x00;
TCNT2=0x00;

GICR|=0x40;
MCUCR=0x01;
GIFR=0x40;


TIMSK=0x41;


ACSR=0x80;
SFIOR=0x00;
	
	
};


SIGNAL(SIG_INTERRUPT0)
{
	if(taqqos>0)
	{
		if(taqqos < YARMDAVR)
		{
			TCCR0=0x04;
			TCNT0= 0xFF - taqqos;
		}
		
	}
	else
	{
			TCCR0=0x04;
			TCNT0= 0xFF - 5;
			jarayon = 1;
			LIGHT_ON;
	}
	
   
}

SIGNAL(SIG_OVERFLOW2)
{
	
}

SIGNAL(SIG_OVERFLOW0)
{
	switch(jarayon)
	{
		case 0:
			TCCR0=0x04;
			TCNT0= 0xFF - 5;
			jarayon = 1;
			LIGHT_ON;
		break;
		
		case 1:
			jarayon = 0;
			TCCR0=0x00;
			TCNT0= 0x00;
			LIGHT_OFF;
		break;
		
		default:
			
		break;
	}
}

int main (void)
{
    char etal = 0;
	Setup();
	sei();
	taqqos = 0;
	
	while(1)
	{
	
		if(PINB != etal)
		{
			etal = PINB;
			if(!(PINB & (1<<PB0)))
			{
				taqqos += QADAM;
				if(taqqos>YARMDAVR)taqqos = YARMDAVR;
				
			}
			
			if(!(PINB & (1<<PB1)))
			{
				if(taqqos >= QADAM) taqqos-= QADAM;
				else taqqos = 0;
				
			}
		
		}		
		
	}

}